//   A derived class implementing minigl using cs4731GL
//   Copyright (C) 1999,2000  Mark R. Stevens
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  
//
//   CS4731: The goal is to derive a class from this base class and
//   implement different components throughout the course.
//
// Additional Modifications
//     Stephen Laverty <steve@WPI.EDU>
//     Jesse Carney Johnson <penguin@WPI.EDU>

// local includes
#include "cs4731GL.h"

#ifdef WIN32                     

// Stephen Laverty <steve@WPI.EDU>
#include <windows.h>
#include <wingdi.h>

#endif

// The real OpenGL implmentation
#ifdef __APPLE_CC__
#include <gl.h>
#include <glu.h>
#include <GLUT/glut.h>
#else
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#endif

//-----------------------------------------------------------------------------
cs4731GL::cs4731GL() {

}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
cs4731GL::~cs4731GL() {

}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglFinish() {

  // Call the OpenGL function to do this.
  glFinish();

}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglShadeModel(MGLenum mode) {

  // Call the OpenGL function to do this.
  glShadeModel((GLenum) mode);

}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglBegin(MGLenum mode) {

  // Call the OpenGL function to do this.
  glBegin((GLenum) mode);

}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglEnd  () {

  // Call the OpenGL function to do this.
  glEnd();

}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglClearColor(float r, float g, float b, float a) {

  // Call the OpenGL function to do this.
  glClearColor(r, g, b, a);

}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglClear(unsigned int type) {

  // Call the OpenGL function to do this.
  glClear(type);

}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglNormal3f(float nx, float ny, float nz) {

  // Call the OpenGL function to do this.
  glNormal3f(nx, ny, nz);

}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglVertex3f(float x, float y, float z) {

  // Call the OpenGL function to do this.
  glVertex3f(x, y, z);

}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglColor3f(float r, float g, float b) {

  // Call the OpenGL function to do this.
  glColor3f(r, g, b);

}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglMaterialf(MGLenum type, 
			  MGLenum pname, 
			  float red, 
			  float green, 
			  float blue, 
			  float alpha) {

  // store the color
  float color[4] = {red, green, blue, alpha};

  // Call the OpenGL function to do this.
  glMaterialfv((GLenum) type, (GLenum) pname, color);

}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglEnable (MGLenum    cap) {

  // Call the OpenGL function to do this.
  glEnable((GLenum) cap);

}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglDisable(MGLenum cap) {

  // Call the OpenGL function to do this.
  glDisable((GLenum) cap);

}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglCullFace(MGLenum type) {

  // Call the OpenGL function to do this.
  glCullFace((GLenum) type);

}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglLightf(MGLenum num, 
		       MGLenum pname, 
		       float x, 
		       float y, 
		       float z, 
		       float w) {

  // light parameters
  float lp[4] = {x, y, z, w};

  // Call the OpenGL function to do this.
  glLightfv((GLenum) num, (GLenum)pname, lp);

}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglPointSize(float size) {

  // Call the OpenGL function to do this.
  glPointSize(size);

}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglVertex2i(int x, int y) {

  // Call the OpenGL function to do this.
  glVertex2i(x, y);

}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglVertex3d(double x, double y, double z)
{
	glVertex3d(x, y, z);
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglutWireCone(double x, double y, double z, double w)
{
	glutWireCone(x, y, (int)z, (int)w);
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglutWireCube(double side)
{
	glutWireCube(side);
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglutWireSphere(double x, double y, double z)
{
	glutWireSphere(x, (int)y, (int)z);
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglutWireTeapot(double size)
{
	glutWireTeapot(size);
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglutWireTorus(double x, double y, double z, double w)
{
	glutWireTorus(x, y, (int)z, (int)w);
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglutWireDodecahedron()
{
	glutWireDodecahedron();
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglutSolidCone(double x, double y, double z, double w)
{
	glutSolidCone(x, y, (int)z, (int)w);
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglutSolidCube(double side)
{
	glutSolidCube(side);
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglutSolidSphere(double x, double y, double z)
{
	glutSolidSphere(x, (int)y, (int)z);
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglutSolidTeapot(double size)
{
	glutSolidTeapot(size);
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglutSolidTorus(double x, double y, double z, double w)
{
	glutSolidTorus(x, y, (int)z, (int)w);
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglutSolidDodecahedron()
{
	glutSolidDodecahedron();
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglColor3d(double r, double g, double b)
{
	glColor3d(r, g, b);
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglLightfv(MGLenum num, MGLenum pname, float components[])
{
	glLightfv((GLenum)num, (GLenum)pname, components);
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglMaterialfv(MGLenum type, MGLenum pname, float components[])
{
	glMaterialfv((GLenum)type, (GLenum)pname, components);
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void cs4731GL::mglViewport(int x, int y, int width, int height) {

  glViewport(x, y, width, height);

}
//-----------------------------------------------------------------------------

// ============================================================================
// = This is where you replace the OpenGL stuff with your own implementation. =
// ============================================================================

//-----------------------------------------------------------------------------
void cs4731GL::mglOrtho2D(float w, float x, float y, float z) {

  // Place your implementation here.
  gluOrtho2D(w, x, y, z);

}
//-----------------------------------------------------------------------------

void cs4731GL::mglTranslated(double x, double y, double z)
{
  // Place your implementation here.
  glTranslated(x, y, z);
}

//-----------------------------------------------------------------------------
void cs4731GL::mglRotated(double angle, double x, double y, double z)
{
  // Place your implementation here.
  glRotated(angle, x, y, z);
}

//-----------------------------------------------------------------------------
void cs4731GL::mglScaled(double x, double y, double z)
{
  // Place your implementation here.
  glScaled(x, y, z);
}

//-----------------------------------------------------------------------------
void cs4731GL::mglTranslatef(float x, float y, float z) {


  // Place your implementation here.
  glTranslatef(x, y, z);

}

//-----------------------------------------------------------------------------
void cs4731GL::mglRotatef(float angle, float x, float y, float z) {

  // Place your implementation here.
  glRotatef(angle, x, y, z);

}

//-----------------------------------------------------------------------------
void cs4731GL::mglScalef(float x, float y, float z) {


  // Place your implementation here.
  glScalef(x, y, z);

}

//-----------------------------------------------------------------------------
void cs4731GL::mglOrtho  (float left,
			float right,
			float bottom,
			float top, 
			float zNear, 
			float zFar) {

  // Place your implementation here.
  glOrtho(left, right, bottom, top, zNear, zFar);
  
}

//-----------------------------------------------------------------------------
void cs4731GL::mglFrustum(float left, 
			float right, 
			float bottom, 
			float top, 
			float zNear, 
			float zFar) {

  // Place your implementation here.
  glFrustum(left, right, bottom, top, zNear, zFar);

}

//-----------------------------------------------------------------------------
void cs4731GL::mgluLookAt(double ex, double ey, double ez, double lx, double ly, double lz, double ux, double uy, double uz)
{
  // Place your implementation here.
  gluLookAt(ex, ey, ez, lx, ly, lz, ux, uy, uz);
}

//-----------------------------------------------------------------------------
void cs4731GL::mglMatrixMode(MGLenum type) {

  // Place your implementation here.
  glMatrixMode((GLenum) type);

}

//-----------------------------------------------------------------------------
void cs4731GL::mglLoadIdentity() {

  // Place your implementation here.
  glLoadIdentity();

}

//-----------------------------------------------------------------------------
void cs4731GL::mglPushMatrix() {

  // Place your implementation here.
  glPushMatrix();

}

//-----------------------------------------------------------------------------
void cs4731GL::mglPopMatrix () {

  // Place your implementation here.
  glPopMatrix();

}

//-----------------------------------------------------------------------------
