//
// 3-D gear wheels.  This program is in the public domain.
//
//
// Original: Brian Paul
// Conversion to GLUT by Mark J. Kilgard 
//

// Modified for use in cs4731 by Mark R. Stevens (February 12, 2000)
// contact: stevensm@cs.wpi.edu with comments / concerns
// 
// Additional Modifications for windows port
//     Paul Tessier<phernost@wpi.edu>
//     Stephen Laverty <steve@WPI.EDU>
//
// C includes
#include <math.h>

// C++ includes
#include <iostream>

// Paul Tessier<phernost@wpi.edu>: Windows fix 
using namespace std;

#ifdef WIN32                     

// Stephen Laverty <steve@WPI.EDU>
#ifndef M_PI
#define M_PI 3.14159
#endif

#endif

// The local includes
#include "minigl.h"
#include "miniglut.h"
#include "evil.h"

//-----------------------------------------------------------------------------
void evil::test1(minigl &mgl, miniglut &mglut) {

  // draw some simple shapes
  mgl.mglBegin (minigl::MGL_TRIANGLES);

  mgl.mglColor3f (1.0, 0.0, 0.0);
  mgl.mglVertex3f (0.0, 0.0, 4.0);

  mgl.mglColor3f (0.0, 1.0, 0.0);
  mgl.mglVertex3f (5.0, 0.0, 4.0);

  mgl.mglColor3f (0.0, 0.0, 1.0);
  mgl.mglVertex3f (5.0, 5.0, 4.0);

  mgl.mglEnd();

}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
void evil::test2(minigl &mgl, miniglut &mglut) {

  // draw some simple shapes
  mgl.mglBegin (minigl::MGL_TRIANGLES);

  mgl.mglColor3f (1.0, 0.0, 0.0);
  mgl.mglVertex3f (0.0, 0.0, 4.0);

  mgl.mglColor3f (0.0, 1.0, 0.0);
  mgl.mglVertex3f (5.0, 0.0, 4.0);

  mgl.mglColor3f (0.0, 0.0, 1.0);
  mgl.mglVertex3f (2.5, 5.0, 4.0);

  mgl.mglEnd();

}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
void evil::test3(minigl &mgl, miniglut &mglut) {

  // draw some simple shapes
  mgl.mglBegin (minigl::MGL_TRIANGLES);

  mgl.mglColor3f (1.0, 0.0, 0.0);
  mgl.mglVertex3f (0.0, 0.0, 4.0);

  mgl.mglColor3f (0.0, 1.0, 0.0);
  mgl.mglVertex3f (5.0, 0.0, 4.0);

  mgl.mglColor3f (0.0, 0.0, 1.0);
  mgl.mglVertex3f (1.0, 5.0, 4.0);

  mgl.mglEnd();

}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
void evil::test4(minigl &mgl, miniglut &mglut) {

  // draw some simple shapes
  mgl.mglBegin (minigl::MGL_TRIANGLES);

  mgl.mglColor3f (1.0, 0.0, 0.0);
  mgl.mglVertex3f (0.0, 0.0, 4.0);

  mgl.mglColor3f (0.0, 1.0, 0.0);
  mgl.mglVertex3f (5.0, 0.0, 4.0);

  mgl.mglColor3f (0.0, 0.0, 1.0);
  mgl.mglVertex3f (4.0, 5.0, 4.0);

  mgl.mglEnd();

}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
void evil::test5(minigl &mgl, miniglut &mglut) {

  // draw some simple shapes
  mgl.mglBegin (minigl::MGL_TRIANGLES);

  mgl.mglColor3f (1.0, 0.0, 0.0);
  mgl.mglVertex3f (0.0, 0.0, 4.0);

  mgl.mglColor3f (0.0, 1.0, 0.0);
  mgl.mglVertex3f (5.0, 5.0, 4.0);

  mgl.mglColor3f (0.0, 0.0, 1.0);
  mgl.mglVertex3f (0.0, 5.0, 4.0);

  mgl.mglEnd();

}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
void evil::test6(minigl &mgl, miniglut &mglut) {

  // draw some simple shapes
  mgl.mglBegin (minigl::MGL_TRIANGLES);

  mgl.mglColor3f (1.0, 0.0, 0.0);
  mgl.mglVertex3f (5.0, 0.0, 4.0);

  mgl.mglColor3f (0.0, 1.0, 0.0);
  mgl.mglVertex3f (5.0, 5.0, 4.0);

  mgl.mglColor3f (0.0, 0.0, 1.0);
  mgl.mglVertex3f (0.0, 5.0, 4.0);

  mgl.mglEnd();

}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
void evil::test7(minigl &mgl, miniglut &mglut) {

  // draw some simple shapes
  mgl.mglBegin (minigl::MGL_TRIANGLES);

  mgl.mglColor3f (1.0, 0.0, 0.0);
  mgl.mglVertex3f (2.5, 0.0, 4.0);

  mgl.mglColor3f (0.0, 1.0, 0.0);
  mgl.mglVertex3f (5.0, 5.0, 4.0);

  mgl.mglColor3f (0.0, 0.0, 1.0);
  mgl.mglVertex3f (0.0, 5.0, 4.0);

  mgl.mglEnd();

}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
void evil::test8(minigl &mgl, miniglut &mglut) {

  // draw some simple shapes
  mgl.mglBegin (minigl::MGL_TRIANGLES);

  mgl.mglColor3f (1.0, 0.0, 0.0);
  mgl.mglVertex3f (0.0, 0.0, 4.0);

  mgl.mglColor3f (0.0, 1.0, 0.0);
  mgl.mglVertex3f (5.0, 2.5, 4.0);

  mgl.mglColor3f (0.0, 0.0, 1.0);
  mgl.mglVertex3f (0.0, 5.0, 4.0);

  mgl.mglEnd();

}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
void evil::test9(minigl &mgl, miniglut &mglut) {

  // draw some simple shapes
  mgl.mglBegin (minigl::MGL_TRIANGLES);

  mgl.mglColor3f (1.0, 0.0, 0.0);
  mgl.mglVertex3f (0.0, 2.5, 4.0);

  mgl.mglColor3f (0.0, 1.0, 0.0);
  mgl.mglVertex3f (5.0, 0.0, 4.0);

  mgl.mglColor3f (0.0, 0.0, 1.0);
  mgl.mglVertex3f (5.0, 5.0, 4.0);

  mgl.mglEnd();

}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void evil::testa(minigl &mgl, miniglut &mglut) {

  // draw some simple shapes
  mgl.mglBegin (minigl::MGL_TRIANGLES);

  mgl.mglColor3f (1.0, 0.0, 0.0);
  mgl.mglVertex3f (0.0, 0.0, 4.0);

  mgl.mglColor3f (0.0, 1.0, 0.0);
  mgl.mglVertex3f (5.0, 0.0, 4.0);

  mgl.mglColor3f (0.0, 0.0, 1.0);
  mgl.mglVertex3f (0.0, 5.0, 4.0);

  mgl.mglEnd();

}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void evil::testb(minigl &mgl, miniglut &mglut) {

  // draw some simple shapes
  mgl.mglBegin (minigl::MGL_TRIANGLES);

  mgl.mglColor3f (1.0, 0.0, 0.0);
  mgl.mglVertex3f (1.0, 1.0, 4.0);

  mgl.mglColor3f (0.0, 1.0, 0.0);
  mgl.mglVertex3f (5.0, 1.0, 4.0);

  mgl.mglEnd();

}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void evil::testc(minigl &mgl, miniglut &mglut) {

  // draw some simple shapes
  mgl.mglBegin (minigl::MGL_QUADS);

  mgl.mglColor3f (1.0, 0.0, 0.0);
  mgl.mglVertex3f (0.0, 0.0, 4.0);

  mgl.mglColor3f (0.0, 1.0, 0.0);
  mgl.mglVertex3f (5.0, 0.0, 4.0);

  mgl.mglColor3f (0.0, 0.0, 1.0);
  mgl.mglVertex3f (5.0, 5.0, 4.0);

  mgl.mglColor3f (1.0, 0.0, 1.0);
  mgl.mglVertex3f (0.0, 5.0, 4.0);

  mgl.mglEnd();

}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void evil::testd(minigl &mgl, miniglut &mglut) {

  // draw some simple shapes
  mgl.mglBegin (minigl::MGL_QUADS);

  mgl.mglColor3f (1.0, 0.0, 0.0);
  mgl.mglVertex3f (0.0, 0.0, 4.0);

  mgl.mglColor3f (0.0, 1.0, 0.0);
  mgl.mglVertex3f (5.0, 0.0, 4.0);

  mgl.mglColor3f (0.0, 0.0, 1.0);
  mgl.mglVertex3f (5.0, 5.0, 4.0);

  mgl.mglEnd();

}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void evil::teste(minigl &mgl, miniglut &mglut) {

  // draw some simple shapes
  mgl.mglBegin (minigl::MGL_POLYGON);

  mgl.mglColor3f (1.0, 1.0, 0.0);
  mgl.mglVertex3f (0.0, 0.0, 4.0);

  mgl.mglColor3f (0.0, 1.0, 1.0);
  mgl.mglVertex3f (5.0, 0.0, 4.0);

  mgl.mglColor3f (1.0, 0.0, 1.0);
  mgl.mglVertex3f (5.0, 5.0, 4.0);

  mgl.mglEnd();

}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void evil::testf(minigl &mgl, miniglut &mglut) {

  // draw some simple shapes
  mgl.mglBegin (minigl::MGL_POLYGON);

  mgl.mglColor3f (1.0, 1.0, 0.0);
  mgl.mglVertex3f (0.0, 0.0, 4.0);

  mgl.mglColor3f (0.0, 1.0, 1.0);
  mgl.mglVertex3f (5.0, 0.0, 4.0);

  mgl.mglEnd();

}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void evil::testg(minigl &mgl, miniglut &mglut) {

  // draw some simple shapes
  mgl.mglBegin (minigl::MGL_TRIANGLE_FAN);

  mgl.mglColor3f (0.0, 0.0, 0.0);
  mgl.mglVertex3f (2.5, 2.5, 4.0);

  for (int i = 0; i <= 360; i+= 45) {

    mgl.mglColor3f (i / 360.0, (360.0 - i) / 360.0, 1.0);
    mgl.mglVertex3f (2 * cos(i * 3.14 / 180.0) + 2.5,
		     2 * sin(i * 3.14 / 180.0) + 2.5,
		     4.0);

  }

  mgl.mglEnd();

}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void evil::testh(minigl &mgl, miniglut &mglut) {

  // draw some simple shapes
  mgl.mglBegin (minigl::MGL_QUAD_STRIP);

  // set the values
  for (int i = 360; i >= 0; i -= 45) {

    mgl.mglColor3f (i / 360.0, (360.0 - i) / 360.0, 1.0);

    float x = cos(i * 3.14 / 180.0);
    float y = sin(i * 3.14 / 180.0);

    mgl.mglVertex3f (2 * x  + 2.5,
		     2 * y  + 2.5,
		     4.0);

    mgl.mglVertex3f (1 * x + 2.5,
		     1 * y + 2.5,
		     4.0);

  }

  mgl.mglEnd();

}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void evil::draw(minigl &mgl, miniglut &mglut)
{

  // clear the screen
  mgl.mglClear(minigl::MGL_COLOR_BUFFER_BIT | minigl::MGL_DEPTH_BUFFER_BIT);

  // the test case loop
  testCase = testCase % 17;

  // depending upon the test case, draw a bunch of shapes
  if (testCase == 0) {
    cout << "\nTesting Triangle: 3 colors, 3 vertices (" << testCase << ")\n";
    testa(mgl, mglut);

  } else if (testCase == 1) {
    cout << "\nTesting Triangle: 3 colors, 2 vertices (" << testCase << ")\n";
    testb(mgl, mglut);

  } else if (testCase == 2) {
    cout << "\nTesting Quad: 4 colors, 4 vertices (" << testCase << ")\n";
    testc(mgl, mglut);

  } else if (testCase == 3) {
    cout << "\nTesting Quad: 4 colors, 3 vertices (" << testCase << ")\n";
    testd(mgl, mglut);

  } else if (testCase == 4) {
    cout << "\nTesting Polygon: 4 colors, 3 vertices (" << testCase << ")\n";
    teste(mgl, mglut);

  } else if (testCase == 5) {
    cout << "\nTesting Polygon: 4 colors, 2 vertices (" << testCase << ")\n";
    testf(mgl, mglut);

  } else if (testCase == 6) {
    cout << "\nTesting Triangle fan: (" << testCase << ")\n";
    testg(mgl, mglut);

  } else if (testCase == 7) {
    cout << "\nTriangle: 3 colors, 3 vertices (" << testCase << ")\n";
    test1(mgl, mglut);

  } else if (testCase == 8) {
    cout << "\nTriangle: 3 colors, 3 vertices (" << testCase << ")\n";
    test2(mgl, mglut);

  } else if (testCase == 9) {
    cout << "\nTriangle: 3 colors, 3 vertices (" << testCase << ")\n";
    test3(mgl, mglut);

  } else if (testCase == 10) {
    cout << "\nTriangle: 3 colors, 3 vertices (" << testCase << ")\n";
    test4(mgl, mglut);

  } else if (testCase == 11) {
    cout << "\nTriangle: 3 colors, 3 vertices (" << testCase << ")\n";
    test5(mgl, mglut);

  } else if (testCase == 12) {
    cout << "\nTriangle: 3 colors, 3 vertices (" << testCase << ")\n";
    test6(mgl, mglut);

  } else if (testCase == 13) {
    cout << "\nTriangle: 3 colors, 3 vertices (" << testCase << ")\n";
    test7(mgl, mglut);

  } else if (testCase == 14) {
    cout << "\nTriangle: 3 colors, 3 vertices (" << testCase << ")\n";
    test8(mgl, mglut);

  } else if (testCase == 15) {
    cout << "\nTriangle: 3 colors, 3 vertices (" << testCase << ")\n";
    test9(mgl, mglut);

  } else {
    cout << "\nTesting Quad strip: 4 colors, 2 vertices (" << testCase << ")\n";
    testh(mgl, mglut);


  }

  // swap the buffers and draw
  mglut.mglutSwapBuffers();

  // count frames and output the frame rate
  Frames++;
  int t = mglut.mglutGet(miniglut::MGLUT_ELAPSED_TIME);
  if (t - T0 >= 5000) {
    float seconds = (t - T0) / 1000.0;
    float fps = Frames / seconds;
    cout << "\t" << Frames << " frames in ";
    cout << seconds << " seconds = " << fps << " fps\n";
    T0 = t;
    Frames = 0;
  }

}
//-----------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
void evil::reshape(minigl &mgl, miniglut &mglut, int width, int height)
{

  // compute the aspect
  float h = static_cast<float>(height) / static_cast<float>(width);

  // set up the viewport
  mgl.mglViewport(0, 0, width, height);

  // set up the projection matrix stack
  mgl.mglMatrixMode(minigl::MGL_PROJECTION);
  mgl.mglLoadIdentity();

  // aspect ratio of the screen
  float aspect = (float) width / (float) height;

  // orthographic projection
  mgl.mglOrtho(0, 5.0 * aspect, 
	       0, 5.0, 
	       -5.0, 5.0);

  // return the the modelview stack for later drawing
  mgl.mglMatrixMode(minigl::MGL_MODELVIEW);

  // set up the modelview matrix stack
  mgl.mglMatrixMode(minigl::MGL_MODELVIEW);
  mgl.mglLoadIdentity();

}
//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
void evil::init(minigl &mgl, miniglut &mglut)
{

  // start at the first test case
  testCase = 0;

  // The timings 
  T0 = 0;
  Frames = 0;

  // initiate backface removal
  mgl.mglEnable(minigl::MGL_CULL_FACE);
  
  // turn on z-buffering
  mgl.mglEnable(minigl::MGL_DEPTH_TEST);

  // turn on vector normalization
  mgl.mglEnable(minigl::MGL_NORMALIZE);

  // smooth shading
  mgl.mglShadeModel (minigl::MGL_SMOOTH);

}
//--------------------------------------------------------------------------------

//--------------------------------------------------------------------------------
void evil::key    (minigl &mgl, miniglut &mglut, unsigned char k, int x, int y) {
  
  // based on the key, update the rotation
  switch (k) {
  case 'n':
    testCase++;
    break;
  case 27:  /* Escape */
    std::exit(0);
    break;
  default:
    return;
  }

  // update the screen
  mglut.mglutPostRedisplay();                                                                        
}
//--------------------------------------------------------------------------------

//--------------------------------------------------------------------------------
void evil::special(minigl &mgl, miniglut &mglut, int k, int x, int y) {

  // based on the key, update the rotation
  switch (k) {
  case 'n':
    testCase++;
    break;
  default:
    return;
  }

  // update the screen
  mglut.mglutPostRedisplay();

}
//--------------------------------------------------------------------------------
void evil::mouse (minigl &mgl, miniglut &mglut, int button, int state, int x, int y){

	mglut.mglutPostRedisplay( );
}

//--------------------------------------------------------------------------------
void evil::usage() {

  // tell the user what the keys do to the evil
  cout << "\nEvil Usage:\n";
  cout << "\tKeys:\n";
  cout << "\t\tn\t\tmove through the test cases\n";
  cout << "\t\tescape\t\texit\n";
  cout << "\tMouse:\n";
  cout << "\t\tNone\n";
}
//--------------------------------------------------------------------------------








