//   Base mini-glut class
//   Copyright (C) 1999,2000  Mark R. Stevens
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 //
//
//   BUG FIXES BY:
//     Stephen Laverty <steve@WPI.EDU>
//     Uri Braun <uri@WPI.EDU>
//     Sean Levatino <levatino@WPI.EDU>
//     Brian J Corcoran <b@WPI.EDU>

// C includes
#include <math.h>

// C++ includes
#include <iostream>

// The local includes
#include "minigl.h"
#include "miniglut.h"
#include "cs4731app.h"

// the true glut
#ifdef __APPLE_CC__ 
#include <GLUT/glut.h>
#else
#include <GL/glut.h>
#endif

// the static member data
cs4731app *miniglut::app;
miniglut  *miniglut::mglut;
minigl    *miniglut::mgl;

//-------------------------------------------------------------------------------------
void miniglut::draw(void) {

  // call the app routine
  app->draw(*mgl, *mglut);

}
//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
void miniglut::reshape(int width, int height) {

  // call the app routine
  app->reshape(*mgl, *mglut, width, height);

}
//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
void miniglut::key(unsigned char k, int x, int y) {     

  // call the app routine
  app->key(*mgl, *mglut, k, x, y);

}

//-------------------------------------------------------------------------------------
void miniglut::mouse(int button, int state, int x, int y) {     

  // call the app routine
  app->mouse(*mgl, *mglut, button, state, x, y);

}

//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
void miniglut::special(int k, int x, int y) {

  // call the special routine
  app->special(*mgl, *mglut, k, x, y);

}
//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
void miniglut::mglutMainLoop() {

  // call the true glut implmentation
  glutMainLoop();
}
//-------------------------------------------------------------------------------------


//-------------------------------------------------------------------------------------
miniglut::miniglut(minigl *ngl, cs4731app *napp, int argc, char *argv[]) {

  // initialize things
  mgl   = ngl;
  app   = napp;
  mglut = this;

  // initialization the true glut
  glutInit(&argc, argv);
  
  // pop up a window
  glutInitDisplayMode(GLUT_RGB | GLUT_DEPTH | GLUT_DOUBLE);

  // create and initialize a window
  glutInitWindowPosition(0, 0);
  //glutInitWindowSize(300, 300);
  glutInitWindowSize(640, 480);
  glutCreateWindow("cs4731");

  // set up the various functions
  glutDisplayFunc(draw);
  glutReshapeFunc(reshape);
  glutKeyboardFunc(key);
  glutMouseFunc(mouse);
  glutSpecialFunc(special);

}
//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
void miniglut::mglutSwapBuffers() {

  // finish rendering
  mgl->mglFinish();

  // call the true glut implementation
  glutSwapBuffers();

}
//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
int miniglut::mglutGet(MGLUTenum type) {

  // call the true glut implementation
  // BUG FIX BY:
  //   Stephen Laverty <steve@WPI.EDU>
  //   Uri Braun <uri@WPI.EDU>
  //   Sean Levatino <levatino@WPI.EDU>
  return glutGet((GLenum) type);

}
//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
void miniglut::mglutPostRedisplay() {

  // call the true glut implementation
  glutPostRedisplay();

}
//-------------------------------------------------------------------------------------





